#include <iostream>
#include <math.h>

using namespace std;

bool IsPeriodicFrac(int b);
void ReductionOfFractions(int &a, int &b, int &min);
void PresSignOfFrac(int &k, int &sign);

int main()
{
	int a, b, min, sign = 1;
	cout << "Input numbers a and b separated by a space: ";
	cin >> a >> b;
	if (b == 0) {
		cout << "Error! b = 0";
		return 1;
	}

	PresSignOfFrac(a, sign);
	PresSignOfFrac(b, sign);

	if (a < b)
		min = a;
	else min = b;
	
	ReductionOfFractions(a, b, min);
	
	if (IsPeriodicFrac(b) == true) {
		if (a / b == 0)
			cout << sign * a << "/" << b;
		else cout << sign * a / b << " " << a - (a / b) * b << "/" << b;
	}
	else cout << sign * ((a * 1.) / (b * 1.));
	
	return 0;
}

void ReductionOfFractions(int &a, int &b, int &min) {
	if (a == b) {
		a = 1;
		b = 1;
	}
	else {
		for (int i = 2; (i <= min / 2 || i <= 2); i++) {
			if (a % i == 0 && b % i == 0) {
				a /= i;
				b /= i;
				min /= i;
				ReductionOfFractions(a, b, min);
				break;
			}
			else ;
		}
	}
}

bool IsPeriodicFrac(int b)
{
	while (b % 2 == 0) 
		b /= 2;
	while (b % 5 == 0) 
		b /= 5;
	if (b != 1)
		return true;
	else return false;
}

void PresSignOfFrac(int &k, int &sign) 
{
	if (k < 0) {
		sign *= -1;
		k = abs(k);
	}
	else ;
}
